Summary:        Python packaging Common Tasks
Name:           python-pyct
Version:        0.5.0
Release: 1%{?dist}

License:        BSD-3-Clause AND ISC
URL:            https://github.com/pyviz-dev/pyct
Source0:        %{pypi_source pyct}

Source10:       pyct.1
Source11:       pyct-report.1

BuildArch:      noarch

ExcludeArch:    %{ix86}

BuildRequires:  python3-devel

BuildRequires:  python3dist(pytest)

%global common_description %{expand:
A utility package that includes:

 1. pyct.cmd: Makes various commands available to other packages. (Currently no
    sophisticated plugin system, just a try import/except in the other
    packages.) The same commands are available from within python. Can either
    add new subcommands to an existing argparse based command if the module has
    an existing command, or create the entire command if the module has no
    existing command. Currently, there are commands for copying examples and
    fetching data.

 2. pyct.build: Provides various commands to help package building, primarily
    as a convenience for project maintainers.}

%description %{common_description}


%package -n python3-pyct
Summary:        %{summary}

Provides:       bundled(python3dist(clint))

%description -n python3-pyct %{common_description}


%package -n python3-pyct+build
Summary: Subpackage for python3-pyct with extra build dependencies
Requires: python3-pyct

%description -n python3-pyct+build
This is the subpackage for python3-pyct with extra build dependencies.

%files -n python3-pyct+build -f %{_pyproject_ghost_distinfo}



%prep
%autosetup -n pyct-%{version} -p1

sed -r -i '/\bflake8\b/d' setup.py

find pyct -type f -exec \
    gawk '/^#!/ { print FILENAME }; { nextfile }' '{}' '+' |
  xargs -r -t sed -r -i '1{/^#!/d}'


%generate_buildrequires
%pyproject_buildrequires -x build,cmd,tests


%build
%pyproject_wheel



%install
%pyproject_install
%pyproject_save_files pyct

install -t '%{buildroot}%{_mandir}/man1' -D -p -m 0644 \
     '%{SOURCE10}' '%{SOURCE11}'


%check
%pytest
(
  set -o errexit
  export PATH="%{buildroot}%{_bindir}:${PATH}"
  export PYTHONPATH='%{buildroot}%{python3_sitelib}'
  %{python3} -c "import pyct; pyct.report('pyct','python','system')"
  %{python3} -c "from pyct.build import examples, get_setup_version"
  pyct --help
  pyct --version
  pyct report --help
  pyct report pyct python
  %{python3} -m pyct --version
)


%files -n python3-pyct -f %{pyproject_files}
%doc README.md

%{_bindir}/pyct
%{_mandir}/man1/pyct.1*
%{_mandir}/man1/pyct-*.1*


%changelog
* Fri Jun 28 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.5.0-1
- initial build
